<?php

function db_getDB()
{
	global $DB_URL, $IS_WEB_REQUEST;
	
	if(!isset($IS_WEB_REQUEST)) {
		// only the web requests are allowed to create dbs
		echo "no web request, no db\n";
		return false;
	}
	
	
	$dbobject = false;
    global $BASE_DIR, $DB_HANDLE;
    if($DB_HANDLE != false) return $DB_HANDLE;
	try {
		$dbobject = new PDO("$DB_URL");
	} catch(PDOException $exep) {
		error_log("execpt on db open");
		return false;
	}
	
	$DB_HANDLE = $dbobject;

	return $dbobject;
}

function db_createDB()
{
	// theres not much to do yet with only sqlite support
}

// all columns end up as text
function db_createTable($tablename)
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	if(db_tableExists($tablename)) return true;
	
	$sql = "create table \"$tablename\" (\"".$tablename."_id\" INTEGER PRIMARY KEY AUTOINCREMENT";
	for($i=1; $i < func_num_args(); $i++) {
		$colname = func_get_arg($i);
		$sql .= ", $colname text";
	}
	$sql .= ")";
	
	//echo "sql: $sql\n";
	$db->query($sql);
}

function db_insertData($tablename)
{

	$db = db_getDB();
	
	if(!$db) return false;
	
	$sql = "insert into \"$tablename\" values (NULL";
	for($i=1; $i < func_num_args(); $i++) {
		$sql .= ",'".func_get_arg($i)."'";
	}
	$sql .=")";
	
	//echo "sql is $sql\n";
	
	$db->query($sql);
}

function db_getMaxValue($tablename, $column, $columnsel="", $wheresel="")
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	if($columnsel != "") {
		$extra = " where $columnsel = '$wheresel'";
	}
	
	$sql = "select max($column) from \"$tablename\"$extra";
	$res = $db->query($sql);
	if(!$res) return false;
	$data = $res->fetchAll();
	
	return $data;
}


function db_selectData($tablename, $column="", $value="", $orderby = "")
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	
	if($column != "") $extra = " where $column like '%$value%'";
	else $extra = "";
	if($orderby != "") $extra .= " order by $orderby";
	$sql = "select * from \"$tablename\"$extra";
	$res = $db->query($sql);
	if(!$res) return false;
	$data = $res->fetchAll();
	
	return $data;
}

function db_deleteData($tablename, $column, $value)
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	$sql = "delete from \"$tablename\" where $column like '%$value%'";
	//echo "Sql is $sql\n";
	return $db->query($sql);
	
}

function db_updateData($tablename, $column, $newdata, $wherecol, $wheredata, $exact=true)
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	if($exact) $sql = "update \"$tablename\" set $column='$newdata' where $wherecol='$wheredata'";
	else $sql = "update \"$tablename\" set $column='$newdata' where $wherecol like '$wheredata'";
	return $db->query($sql);
}

function db_deleteTable($tablename)
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	$sql = "drop table $tablename";
	
	return $db->query($sql);
}

function db_tableExists($tablename)
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	$sql = "select count(*) from sqlite_master where type='table' and name='$tablename'";
	$res = $db->query($sql);
	
	$value = $res->fetchColumn();
	
	if($value == 1) return true;
	else return false;
}

function db_getTables()
{
	$db = db_getDB();
	
	if(!$db) return false;
	
	$sql = "select name from sqlite_master where type='table' and name not like 'sqlite_%'";
	$res = $db->query($sql);
	
	return $res->fetchAll();
}
?>